unit MMSHelpers;

interface

function HttpGet(const urlHost: string; urlPort: integer; const urlPath:
    string; var pageContents: string; const userAgent: string): boolean;

implementation

uses
  SysUtils,
  Classes,
  WinINet;

{ helpers }

function Asgn(var handle: HINTERNET; apiResult: HINTERNET): boolean;
begin
  handle := apiResult;
  Result := assigned(apiResult);
end; { Asgn }

function HttpGet(const urlHost: string; urlPort: integer; const urlPath:
    string; var pageContents: string; const userAgent: string): boolean;
var
  bufResponse: array [1..16384] of byte;
  bytesRead  : cardinal;
  hConnect   : HINTERNET;
  hOpen      : HINTERNET;
  hRequest   : HINTERNET;
  httpFlags  : cardinal;
  strResponse: TStringStream;
begin
  Result := false;
  if not Asgn(hOpen, InternetOpen(PChar(userAgent),
           INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0)) then Exit;
  try
    if not Asgn(hConnect, InternetConnect(hOpen, PChar(urlHost),
             urlPort, nil, nil, INTERNET_SERVICE_HTTP, 0, 0)) then Exit;
    try
      httpFlags := INTERNET_FLAG_RELOAD OR INTERNET_FLAG_NO_CACHE_WRITE OR
        INTERNET_FLAG_NO_AUTO_REDIRECT OR INTERNET_FLAG_NO_UI;
      if not Asgn(hRequest, HttpOpenRequest(hConnect, 'GET', PChar(urlPath), 'HTTP/1.0',
               nil, nil, httpFlags, 0)) then Exit;
      try
        if not HttpSendRequest(hRequest, nil, 0, nil, 0) then
          raise Exception.CreateFmt('Failed to GET http://%s/%s', [urlHost, urlPath]);
        strResponse := TStringStream.Create('');
        try
          repeat
            if not InternetReadFile(hRequest, @bufResponse, SizeOf(bufResponse),
                     bytesRead) then Exit;
            if bytesRead = 0 then
              break; //repeat
            strResponse.Write(bufResponse, bytesRead);
          until false;
          pageContents := strResponse.DataString;
          Result := true;
        finally FreeAndNil(strResponse); end;
      finally InternetCloseHandle(hRequest); end;
    finally InternetCloseHandle(hConnect); end;
  finally InternetCloseHandle(hOpen); end;
end; { HttpGet }

end.
