unit SimplePipeline1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  OtlCommon,
  OtlCollections,
  OtlParallel;

type
  TfrmSimplePipeline = class(TForm)
    btnPipeline: TButton;
    btnExceptions: TButton;
    lbLog: TListBox;
    procedure btnPipelineClick(Sender: TObject);
    procedure btnExceptionsClick(Sender: TObject);
  private
  public
  end;

var
  frmSimplePipeline: TfrmSimplePipeline;

implementation

{$R *.dfm}

procedure AddOne(const input, output: IOmniBlockingCollection);
var
  v: TOmniValue;
begin
  for v in input do
    output.Add(v.AsInteger + 1);
end;

procedure Invert(const input: TOmniValue; var output: TOmniValue);
begin
  output := 1/input.AsDouble;
end;

procedure IntToString(const input: TOmniValue; var output: TOmniValue);
begin
  if input.IsException then
    output := input.AsException.Message
  else
    output := Format('%.4f', [input.AsDouble]);
end;

procedure TfrmSimplePipeline.btnPipelineClick(Sender: TObject);
var
  pipeline: IOmniPipeline;
  i: Integer;
  v: TOmniValue;
begin
  pipeline := Parallel.Pipeline;
  pipeline.Stage(AddOne);
  pipeline.Stage(Invert);
  pipeline.Run;

  for i := 1 to 5 do
    pipeline.Input.Add(i);
  pipeline.Input.CompleteAdding;

  for v in pipeline.Output do
    lbLog.Items.Add(Format('%.3f', [v.AsDouble]));

  pipeline := nil;
end;

procedure TfrmSimplePipeline.btnExceptionsClick(Sender: TObject);
var
  pipeline: IOmniPipeline;
  i: Integer;
  v: TOmniValue;
begin
  pipeline := Parallel.Pipeline;
  pipeline.Stage(AddOne);
  pipeline.Stage(Invert);
  pipeline.Stage(IntToString).HandleExceptions;
  pipeline.Run;

  for i := 3 downto -2 do
    pipeline.Input.Add(i);
  pipeline.Input.CompleteAdding;

  for v in pipeline.Output do
    lbLog.Items.Add(v);

  pipeline := nil;
end;

end.
